///****************************************************************************
//// Name:        DFTTSSampleCPP with DFTTS Desktop SDK v 3.5.0
//// Purpose:
//// Author:      Digital Future
//// Modified by:
//// Created:     06/19/2008, finalized for version 3.5.0 7/19/2008
//// RCS-ID:
//// Copyright:   (C) Digital Future 2008. All rights reserved.
//// License:     see license document
//***************************************************************************/

#include "stdafx.h"
#include "resource.h"


#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	SpeechDlgProc(HWND, UINT, WPARAM, LPARAM);

//DF TTS OnWord callback
VOID callBackOnWord( int start, int end );

//DF TTS OnExport callback
VOID callBackOnExport( int start, int end );

//Helper to get the text from the text edit (always MUST free() after use)
char* GetTextFromEditCtrl( HWND hwndTxtEdit, DWORD* bytes);

//Is the voice paused?
BOOL isPaused = FALSE;

//Is the voice speaking?
BOOL isSpeaking = FALSE;

//Export file name
char* szFileName = "test.wav";

//VoiceInfo combo data
DFTTSVoiceInfo* g_vi = 0;

//Export formats for VoiceText (TM) voices
enum
{
    VT_FILE_API_FMT_S16PCM = 0,
    VT_FILE_API_FMT_ALAW = 1,
    VT_FILE_API_FMT_MULAW = 2,
    VT_FILE_API_FMT_DADPCM = 3,
    VT_FILE_API_FMT_S16PCM_WAVE = 4,
    VT_FILE_API_FMT_U08PCM_WAVE = 5,
    VT_FILE_API_FMT_IMA_WAVE = 6,
    VT_FILE_API_FMT_ALAW_WAVE = 7,
    VT_FILE_API_FMT_MULAW_WAVE = 8,
    VT_FILE_API_FMT_MULAW_AU = 9

};

//Export formats for Cepstral voices
/*

	See function DFTTSExportToFileEx in dftts.h

	You need to set the following instead:

	char* szAudioEncoding [possible values:
		* "pcm16", "pcm8" PCM 16 bit/8 bit WAV
		* "ulaw" - -Law (8-bit by definition), "alaw" - A-Law (8-bit by definition)
		* "riff": Microsoft RIFF (WAV) file
		* "snd": Sun/NeXT .au (SND) format.
		* "raw": unheadered audio data, native byte order
		* "le": unheadered audio data, little-endian (LSB first)
		* "be": unheadered audio data, big-endian (MSB first)
		* NOTE: that not all encoding types may be supported by all formats. For instance, SND doesn't support A-Law. ],

	int iAudioSamplingRate [possible values: 8000 (8 KHz), 16000 (16 KHz), 11025 (11.025 kHz), etc ],

	int iAudioChannels [possible values: 1 (mono), 2 (stereo)]

*/

/*

Export formats for AT&T NV (INTERNAL USE ONLY, USE ANY ATTNV WITH ENGINE TYPE MSSAPI ON WINDOWS)

Currently only PCM WAV supported (all audio format arguments will be ignored)

*/

/*

Export formats for Microsoft SAPI 5.x (MSSAPI)

*/

typedef enum SPSTREAMFORMAT
    {
	SPSF_Default	= -1,
	SPSF_NoAssignedFormat	= 0,
	SPSF_Text	= SPSF_NoAssignedFormat + 1,
	SPSF_NonStandardFormat	= SPSF_Text + 1,
	SPSF_ExtendedAudioFormat	= SPSF_NonStandardFormat + 1,
	SPSF_8kHz8BitMono	= SPSF_ExtendedAudioFormat + 1,
	SPSF_8kHz8BitStereo	= SPSF_8kHz8BitMono + 1,
	SPSF_8kHz16BitMono	= SPSF_8kHz8BitStereo + 1,
	SPSF_8kHz16BitStereo	= SPSF_8kHz16BitMono + 1,
	SPSF_11kHz8BitMono	= SPSF_8kHz16BitStereo + 1,
	SPSF_11kHz8BitStereo	= SPSF_11kHz8BitMono + 1,
	SPSF_11kHz16BitMono	= SPSF_11kHz8BitStereo + 1,
	SPSF_11kHz16BitStereo	= SPSF_11kHz16BitMono + 1,
	SPSF_12kHz8BitMono	= SPSF_11kHz16BitStereo + 1,
	SPSF_12kHz8BitStereo	= SPSF_12kHz8BitMono + 1,
	SPSF_12kHz16BitMono	= SPSF_12kHz8BitStereo + 1,
	SPSF_12kHz16BitStereo	= SPSF_12kHz16BitMono + 1,
	SPSF_16kHz8BitMono	= SPSF_12kHz16BitStereo + 1,
	SPSF_16kHz8BitStereo	= SPSF_16kHz8BitMono + 1,
	SPSF_16kHz16BitMono	= SPSF_16kHz8BitStereo + 1,
	SPSF_16kHz16BitStereo	= SPSF_16kHz16BitMono + 1,
	SPSF_22kHz8BitMono	= SPSF_16kHz16BitStereo + 1,
	SPSF_22kHz8BitStereo	= SPSF_22kHz8BitMono + 1,
	SPSF_22kHz16BitMono	= SPSF_22kHz8BitStereo + 1,
	SPSF_22kHz16BitStereo	= SPSF_22kHz16BitMono + 1,
	SPSF_24kHz8BitMono	= SPSF_22kHz16BitStereo + 1,
	SPSF_24kHz8BitStereo	= SPSF_24kHz8BitMono + 1,
	SPSF_24kHz16BitMono	= SPSF_24kHz8BitStereo + 1,
	SPSF_24kHz16BitStereo	= SPSF_24kHz16BitMono + 1,
	SPSF_32kHz8BitMono	= SPSF_24kHz16BitStereo + 1,
	SPSF_32kHz8BitStereo	= SPSF_32kHz8BitMono + 1,
	SPSF_32kHz16BitMono	= SPSF_32kHz8BitStereo + 1,
	SPSF_32kHz16BitStereo	= SPSF_32kHz16BitMono + 1,
	SPSF_44kHz8BitMono	= SPSF_32kHz16BitStereo + 1,
	SPSF_44kHz8BitStereo	= SPSF_44kHz8BitMono + 1,
	SPSF_44kHz16BitMono	= SPSF_44kHz8BitStereo + 1,
	SPSF_44kHz16BitStereo	= SPSF_44kHz16BitMono + 1,
	SPSF_48kHz8BitMono	= SPSF_44kHz16BitStereo + 1,
	SPSF_48kHz8BitStereo	= SPSF_48kHz8BitMono + 1,
	SPSF_48kHz16BitMono	= SPSF_48kHz8BitStereo + 1,
	SPSF_48kHz16BitStereo	= SPSF_48kHz16BitMono + 1,
	SPSF_TrueSpeech_8kHz1BitMono	= SPSF_48kHz16BitStereo + 1,
	SPSF_CCITT_ALaw_8kHzMono	= SPSF_TrueSpeech_8kHz1BitMono + 1,
	SPSF_CCITT_ALaw_8kHzStereo	= SPSF_CCITT_ALaw_8kHzMono + 1,
	SPSF_CCITT_ALaw_11kHzMono	= SPSF_CCITT_ALaw_8kHzStereo + 1,
	SPSF_CCITT_ALaw_11kHzStereo	= SPSF_CCITT_ALaw_11kHzMono + 1,
	SPSF_CCITT_ALaw_22kHzMono	= SPSF_CCITT_ALaw_11kHzStereo + 1,
	SPSF_CCITT_ALaw_22kHzStereo	= SPSF_CCITT_ALaw_22kHzMono + 1,
	SPSF_CCITT_ALaw_44kHzMono	= SPSF_CCITT_ALaw_22kHzStereo + 1,
	SPSF_CCITT_ALaw_44kHzStereo	= SPSF_CCITT_ALaw_44kHzMono + 1,
	SPSF_CCITT_uLaw_8kHzMono	= SPSF_CCITT_ALaw_44kHzStereo + 1,
	SPSF_CCITT_uLaw_8kHzStereo	= SPSF_CCITT_uLaw_8kHzMono + 1,
	SPSF_CCITT_uLaw_11kHzMono	= SPSF_CCITT_uLaw_8kHzStereo + 1,
	SPSF_CCITT_uLaw_11kHzStereo	= SPSF_CCITT_uLaw_11kHzMono + 1,
	SPSF_CCITT_uLaw_22kHzMono	= SPSF_CCITT_uLaw_11kHzStereo + 1,
	SPSF_CCITT_uLaw_22kHzStereo	= SPSF_CCITT_uLaw_22kHzMono + 1,
	SPSF_CCITT_uLaw_44kHzMono	= SPSF_CCITT_uLaw_22kHzStereo + 1,
	SPSF_CCITT_uLaw_44kHzStereo	= SPSF_CCITT_uLaw_44kHzMono + 1,
	SPSF_ADPCM_8kHzMono	= SPSF_CCITT_uLaw_44kHzStereo + 1,
	SPSF_ADPCM_8kHzStereo	= SPSF_ADPCM_8kHzMono + 1,
	SPSF_ADPCM_11kHzMono	= SPSF_ADPCM_8kHzStereo + 1,
	SPSF_ADPCM_11kHzStereo	= SPSF_ADPCM_11kHzMono + 1,
	SPSF_ADPCM_22kHzMono	= SPSF_ADPCM_11kHzStereo + 1,
	SPSF_ADPCM_22kHzStereo	= SPSF_ADPCM_22kHzMono + 1,
	SPSF_ADPCM_44kHzMono	= SPSF_ADPCM_22kHzStereo + 1,
	SPSF_ADPCM_44kHzStereo	= SPSF_ADPCM_44kHzMono + 1,
	SPSF_GSM610_8kHzMono	= SPSF_ADPCM_44kHzStereo + 1,
	SPSF_GSM610_11kHzMono	= SPSF_GSM610_8kHzMono + 1,
	SPSF_GSM610_22kHzMono	= SPSF_GSM610_11kHzMono + 1,
	SPSF_GSM610_44kHzMono	= SPSF_GSM610_22kHzMono + 1,
	SPSF_NUM_FORMATS	= SPSF_GSM610_44kHzMono + 1
} 	SPSTREAMFORMAT;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_DFTTSSAMPLECPP, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_DFTTSSAMPLECPP);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_DFTTSSAMPLECPP);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_DFTTSSAMPLECPP;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   //HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable


   DialogBox(hInst, (LPCTSTR)IDD_SPEECHDLG, NULL, (DLGPROC)SpeechDlgProc);


   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message)
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			// Parse the menu selections:
			switch (wmId)
			{

				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


// Mesage handler for the Speech box
LRESULT CALLBACK SpeechDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			{
				//Set the initial text into the text box
				TCHAR* szStartText = "Enter text here.";
				HWND hwndTxtBox = GetDlgItem(hDlg,IDC_EDIT1);
				SendMessage( hwndTxtBox, WM_SETTEXT, 0, (LPARAM)(LPCTSTR)szStartText );

				//Initilize voices and set the callback

				//Set the OnWord callback function

				SetDFTTSOnWordCallBack( callBackOnWord );

				//Set the OnExport callback function

				SetDFTTSOnExportCallBack( callBackOnExport );


				//Init voice engines (IMPORTANT: SET YOUR OWN PATHS HERE FOR THE LISTED VOICES.
				//ALL OTHER VOICES ARE INITIALIZED AUTOMATICALLY)

				char* szNeospDBPaths[NEOSPEECH_NUM_VOICES] =
				{
					NULL, //Kate
					"C:\\Program Files\\VW\\VT\\Paul\\M16", //Paul
					NULL, //Miyu
					NULL,	//Show
					NULL,	//Misaki
					NULL,	//Lily
					NULL,	//Wang
					NULL,	//Junwoo
					NULL,	//Sujin
					NULL,	//Yumi
					NULL,	//Gyuri
					NULL	//Dayoung
				};

				char* szNeospLicPaths[NEOSPEECH_NUM_VOICES] =
				{
					NULL, //Kate
					"C:\\Program Files\\VW\\VT\\Paul\\M16\\data-common\\verify\\verification.txt", //Paul
					NULL, //Miyu
					NULL,	//Show
					NULL,	//Misaki
					NULL,	//Lily
					NULL,	//Wang
					NULL,	//Junwoo
					NULL,	//Sujin
					NULL,	//Yumi
					NULL,	//Gyuri
					NULL	//Dayoung
				};


				InitDFTTSEngineReturnValueEx* initresult = InitDFTTSEngineEx( hDlg, szNeospDBPaths, szNeospLicPaths );

				/****************************************************

				initresult is an pointer to InitDFTTSEngineReturnValueEx with 2 array members.

				//NEOSPEECHVOICETEXT ENGLISH
				initresult.vet[0] = NEOSPEECHVOICETEXT; //KATE
				initresult.vet[1] = NEOSPEECHVOICETEXT; //PAUL

				//NEOSPEECHVOICETEXT JAPANESE
				initresult.vet[2] = NEOSPEECHVOICETEXT; //MIYU
				initresult.vet[3] = NEOSPEECHVOICETEXT; //SHOW
				initresult.vet[4] = NEOSPEECHVOICETEXT; //MISAKI

				//NEOSPEECHVOICETEXT CHINESE
				initresult.vet[5] = NEOSPEECHVOICETEXT; //LILY
				initresult.vet[6] = NEOSPEECHVOICETEXT; //WANG

				//NEOSPEECHVOICETEXT KOREAN
				initresult.vet[7] = NEOSPEECHVOICETEXT; //JUNWOO
				initresult.vet[8] = NEOSPEECHVOICETEXT; //SUJIN
				initresult.vet[9] = NEOSPEECHVOICETEXT; //YUMI
				initresult.vet[10] = NEOSPEECHVOICETEXT; //GYURI
				initresult.vet[11] = NEOSPEECHVOICETEXT; //DAYOUNG

				//CEPSTRAL
				initresult.vet[12] = CEPSTRAL;

				//AT&T NV
				initresult.vet[13] = ATTNV; //(!NOT OFFICIALLY SUPPORTED. RUNTIME DISTRIBUTION NOT ALLOWED!)

				ert memebers are of type InitDFTTSEngineReturnValue

				initresult.ert[0] - error code for NeoSpeech Kate
				initresult.ert[1] - error code for NeoSpeech Paul
				initresult.ert[2] - error code for NeoSpeech Miyu
				initresult.ert[3] - error code for NeoSpeech Show
				initresult.ert[4] - error code for NeoSpeech Misaki
				initresult.ert[5] - error code for NeoSpeech Lily
				initresult.ert[6] - error code for NeoSpeech Wang
				initresult.ert[7] - error code for NeoSpeech Junwoo
				initresult.ert[8] - error code for NeoSpeech Sujin
				initresult.ert[9] - error code for NeoSpeech Yumi
				initresult.ert[10] - error code for NeoSpeech Gyuri
				initresult.ert[11] - error code for NeoSpeech Dayoung
				initresult.ert[12] - error code for the whole Cepstral engine
				initresult.ert[13] - error code for the whole AT&T NV engine //(!NOT OFFICIALLY SUPPORTED. RUNTIME DISTRIBUTION NOT ALLOWED!)


				*****************************************************/

				char* szEngineVoiceNames[NUM_ENGINE_INITIALIZATIONS] =
				{"NeoSpeech Kate","NeoSpeech Paul","NeoSpeech Miyu","NeoSpeech Show",
				"NeoSpeech Misaki","NeoSpeech Lily","NeoSpeech Wang","NeoSpeech Junwoo",
				"NeoSpeech Sujin","NeoSpeech Yumi","NeoSpeech Gyuri","NeoSpeech Dayoung",
				"Cepstral engine","AT&T NV engine","MAC OS X SPMAN","MS SAPI"};

				for( size_t y=0;y<NUM_ENGINE_INITIALIZATIONS;y++ )
				{

					if( initresult->ert[y] != INIT_DFTTS_ENGINE_SUCCESS )
					{

						stringstream sstrErrNo;

						sstrErrNo<<(short)initresult->ert[y];

						OutputDebugString(szEngineVoiceNames[y]);

						OutputDebugString(" initialization error: ");

						OutputDebugString( (sstrErrNo.str()).c_str() );

						OutputDebugString( ".\nThe voice or engine may not be installed " \
							"or you specified wrong voice path (in the case of a NeoSpeech voice).\n" );


					}


				}


				//This is how to list all installed supported voices


				char szVoiceName[1024];

				int iVoiceNameLen = 0;

				DFTTSVoiceEngineType vet = NOENGINE;

				unsigned short lang = LANG_SUBLANG_NEUTRAL;

				int iVoiceID = -1;

				HWND hwndComboBox = GetDlgItem( hDlg, IDC_COMBO1 );

				bool bSetDefault = false;

				int z=0;

				for( ; ; z++ )
				{
					DFTTSVoiceInfoReturnValue result = GetDFTTSVoice(
						z, &vet, szVoiceName, &iVoiceNameLen,
						&iVoiceID, &lang );
#if _DEBUG
					switch( result )
					{
					case GET_DFTTS_VI_SUCCESS:
						OutputDebugString( "GET_DFTTS_VI_SUCCESS\n" );
						break;
					case GET_DFTTS_VI_NO_MORE_ITEMS:
						OutputDebugString(  "GET_DFTTS_VI_NO_MORE_ITEMS" );
						break;
					case GET_DFTTS_VI_ERROR_BUFFER_TOO_SMALL:
						OutputDebugString(  "GET_DFTTS_VI_ERROR_BUFFER_TOO_SMALL" );
						break;
					case GET_DFTTS_VI_ERROR_OTHER:
						OutputDebugString(  "GET_DFTTS_VI_ERROR_OTHER" );
						break;
					}

#endif

					if( result == GET_DFTTS_VI_SUCCESS )
					{

#if _DEBUG

						string msg = string("Voice Name: ") + string(szVoiceName) + string("\n");

						if( vet == (short)NEOSPEECHVOICETEXT )
							msg += string("Engine: NEOSPEECHVOICETEXT.\n");
						else if( vet == (short)CEPSTRAL )
							msg += string("Engine: CEPSTRAL.\n");
						else if( vet == (short)MSSAPI )
							msg += string("Engine: MSSAPI.\n");
						else if( vet == (short)ATTNV )
							msg += string("Engine: ATTNV (Internal use only - use MSSAPI).\n");
						else
							msg += string("Engine: NO OFFICIALLY SUPPORTED.\n");


						OutputDebugString( msg.c_str() );

#endif
						DFTTSVoiceInfo* vi = new DFTTSVoiceInfo;

						vi->iVoiceID = iVoiceID;
						vi->lang = lang;
						vi->szVoiceName = new char[strlen(szVoiceName)+1];
						strcpy( vi->szVoiceName, szVoiceName );
						vi->vet = vet;


						LRESULT cindex = ::SendDlgItemMessage(hDlg, IDC_COMBO1,
							CB_ADDSTRING, 0, (LPARAM)szVoiceName );

						if (cindex == CB_ERR || cindex == CB_ERRSPACE)
						{
							MessageBox( NULL,
								"Error when adding voices to voice combo box: OUT OF MEMORY!",
								NULL, MB_OK
								);

							delete[] vi->szVoiceName;
							delete vi;
						}
						else
						{

							::SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETITEMDATA, cindex, (LPARAM)vi);

							if (!bSetDefault)
							{
								::SendDlgItemMessage(hDlg, IDC_COMBO1, CB_SETCURSEL, cindex, 0);
								bSetDefault = true;
							}
						}

					}
					else
					{
						break;
					}


				}

				if( z == 0 )
					MessageBox( NULL, "No voices can be found on your system! Please download and install at least 1 voice!", NULL, MB_OK );
				else
				{

					//Set the global voice info
					int index  = SendDlgItemMessage( hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0 );

					g_vi = (DFTTSVoiceInfo*)SendDlgItemMessage( hDlg, IDC_COMBO1,
															CB_GETITEMDATA, index, 0 );

				}

				//How to load a user dictionary
				//(read dictionary documentation per engine located in folder DictionarySystems)

				LoadDFTTSUserDictReturnValue dictreturn = LOAD_USER_DICT_SUCCESS;

				/* Example for engine NEOSPEECHVOICETEXT */

				//This is how to load a dictionary for the NeoSpeech provider (the dictionary is loaded
				//by language from a file (see file in exe directory) (the dict name, voice name, dict content do NOT matter),
				//the dictionary number matters)


				/*dictreturn = LoadDFTTSUserDict( 0, NULL,
						"neospeech_userdict_eng.csv",
						NEOSPEECHVOICETEXT, MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US), NULL, NULL );*/


				/* Example for engine CEPSTRAL */

				//This is how to load a dictionary for the Cepstral provider (the dictionary is loaded
				//by voice from a file (see file in exe directory);
				//The dictionary number, dict name, dict content do NOT matter.)

				/*dictreturn = LoadDFTTSUserDict( -1, NULL,
						"cepstral_dictionary.txt",
						CEPSTRAL, LANG_SUBLANG_NEUTRAL, "David", NULL );*/

				/* Example for engine MSSAPI */

				//This is how to load a dictionary for the MSSAPI provider (emulated to fit the DF TTS SDK concepts)
				//(the dictionary is loaded by dict name and the phoneme content is specified
				//in code here - Please see documentation in folder DictionarySystems ).
				//The dictionary number, dict file, voice name do NOT matter.

				/*char* szDictContent = "\ntomato {t ow - m ah 1 t ow}\n";

				dictreturn = LoadDFTTSUserDict( -1, "Dict1",
						NULL,
						MSSAPI,
						MAKELANGID(LANG_ENGLISH,SUBLANG_ENGLISH_US),
						NULL,
						szDictContent );*/


					if( dictreturn != LOAD_USER_DICT_SUCCESS )
					{
						char szMsg[256];

						sprintf( szMsg, "Dictionary load error: %d", (short)dictreturn );

						MessageBox(NULL,szMsg,"Error",MB_OK);

					}

				return TRUE;
			}
		case WM_CLOSE:
			{
				
				//Stop if the voice is still speaking
				if( isSpeaking )
					DFTTSStop( g_vi->vet, g_vi->lang );
			
				//Unint the engines and voices
				UninitDFTTSEngine();

				//Clean the voice info data (IMPORTANT!)

				LRESULT cb_count = (LRESULT)SendDlgItemMessage( hDlg, IDC_COMBO1,
                                                        CB_GETCOUNT, 0, 0 );

				for( size_t i=0; i<(size_t)cb_count;i++)
				{
					DFTTSVoiceInfo* vi = (DFTTSVoiceInfo*)SendDlgItemMessage( hDlg, IDC_COMBO1,
															CB_GETITEMDATA, i, 0 );
					delete[] vi->szVoiceName;

					delete vi;
				}

				EndDialog(hDlg, LOWORD(wParam));
				PostQuitMessage(0);
				return TRUE;
			}
		case WM_COMMAND:
			{
				if ( (int)LOWORD(wParam) == IDC_COMBO1 )
				{
					//Set g_vi for the selection

					UINT codeNotify = (UINT)HIWORD(wParam);

					if( codeNotify == CBN_SELCHANGE )
					{
						int index  = SendDlgItemMessage( hDlg, IDC_COMBO1, CB_GETCURSEL, 0, 0 );

						g_vi = (DFTTSVoiceInfo*)SendDlgItemMessage( hDlg, IDC_COMBO1,
                                                        CB_GETITEMDATA, index, 0 );


					}

				}
				else if ( LOWORD(wParam) == IDSPEAK )
				{

					HWND hwndTxtBox = GetDlgItem(hDlg,IDC_EDIT1);

					char* pszText = GetTextFromEditCtrl( hwndTxtBox, NULL );


					DFTTSSpeakReturnValue result = DFTTSSpeak(
						hDlg,g_vi->vet,g_vi->szVoiceName,g_vi->iVoiceID,
						g_vi->lang,pszText,-1,-1,-1,-1,
						-1, DFTTS_TEXT_TYPE_XML, (short)SPSF_16kHz16BitStereo );



					//A MUST!
					free((void*)pszText);

					//Error checking

					if( result != DFTTS_SPEAK_SUCCESS )
					{
						char szMsg[256];

						sprintf( szMsg, "SDK Speak error: %d", (short)result );

						MessageBox(NULL,szMsg,"Error",MB_OK);

					}
					else
						isSpeaking = TRUE;



				}
				else if ( LOWORD(wParam) == IDPAUSERESUME )
				{

					if( isPaused )
					{
						isPaused = FALSE;

						DFTTSResumeReturnValue result = DFTTSResume( g_vi->vet, g_vi->lang );

						if( result != DFTTS_RESUME_SUCCESS )
						{
							char szMsg[256];

							sprintf( szMsg, "SDK Resume error: %d", (short)result );

							MessageBox(NULL,szMsg,"Error",MB_OK);

						}
					}
					else if( !isPaused )
					{
						isPaused = TRUE;

						DFTTSPauseReturnValue result = DFTTSPause( g_vi->vet, g_vi->lang );

						if( result != DFTTS_PAUSE_SUCCESS )
						{
							char szMsg[256];

							sprintf( szMsg, "SDK Pause error: %d", (short)result );

							MessageBox(NULL,szMsg,"Error",MB_OK);

						}

					}


				}
				else if ( LOWORD(wParam) == IDSTOP )
				{

					DFTTSStopReturnValue result = DFTTSStop( g_vi->vet, g_vi->lang );

					if( result != DFTTS_STOP_SUCCESS )
					{
						char szMsg[256];

						sprintf( szMsg, "SDK Stop error: %d", (short)result );

						MessageBox(NULL,szMsg,"Error",MB_OK);

					}
					else
						isSpeaking = FALSE;


				}
				else if ( LOWORD(wParam) == IDEXPORT )
				{


					HWND hwndTxtBox = GetDlgItem(hDlg,IDC_EDIT1);

					char* pszText = GetTextFromEditCtrl( hwndTxtBox, NULL );

					short format = 0;

					switch( g_vi->vet )
					{
					case NEOSPEECHVOICETEXT:
						format = VT_FILE_API_FMT_S16PCM_WAVE;
						break;
					case MSSAPI:
						format = SPSF_16kHz16BitMono;
						break;
					}


					DFTTSExportReturnValue result = (DFTTSExportReturnValue)DFTTSExportToFileEx(
							g_vi->vet,
							g_vi->szVoiceName, g_vi->iVoiceID,
							g_vi->lang, pszText, -1,
							-1, -1, -1,
							-1, DFTTS_TEXT_TYPE_XML,
							szFileName, format,
							"pcm16", 16000,
							2);



					//A MUST!
					free((void*)pszText);

					//Error checking

					if( result != DFTTS_EXPORT_SUCCESS )
					{
						char szMsg[256];

						sprintf( szMsg, "SDK Export error: %d", (short)result );

						MessageBox(NULL,szMsg,"Error",MB_OK);

					}



				}


				break;

			}



	}

    return FALSE;
}

VOID callBackOnWord( int start, int end )
{
	
	if( start==0 && end==-1 )
		isSpeaking = FALSE;

	char szMsg[256];

	sprintf( szMsg, "Start character: %d. End character: %d.\n", start, end );

	OutputDebugString( szMsg );

}

VOID callBackOnExport( int start, int end )
{

	char szMsg[256];

	sprintf( szMsg, "Start exp. character: %d. End exp. character: %d.\n", start, end );

	OutputDebugString( szMsg );

	MessageBox(NULL,"Export successful!","Export Status",MB_OK);

}

char* GetTextFromEditCtrl( HWND hwndTxtEdit, DWORD* bytes)
{

	size_t length = (DWORD)SendMessage(hwndTxtEdit, WM_GETTEXTLENGTH, 0, 0);

	char* pszStr = (char*)malloc((length+1)/**sizeof(char)*/);

    SendMessage(hwndTxtEdit, WM_GETTEXT,length+1, (LPARAM)pszStr);

	if( bytes!= NULL )
		*bytes = (length+1)/**sizeof(char)*/;


	return pszStr;

}